//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Agent.h: interface for the Agent class.
//
//	This class is a wrapper for agents. Agents are a name that has been
//	adopted from Agency, but it is somewhat misleading. The agents should instead
//	be seen as independent components of the fitness function. No mention of
//	the word agent is made outside the code for that reason.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AGENT_H__09E891F7_2DAE_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_AGENT_H__09E891F7_2DAE_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include <vector>
//#include "Individual.h"

using namespace std;

class Scaffold;
class Individual;

class Agent  
{
public:
	Agent();
	Agent(int ID, double weight)	{_ID = ID; _weight = weight;};
	virtual ~Agent();
	//The agent has a name that indicates its function
	virtual	string	getName() = 0;
	//Like everything else, we have an ID
	int				getID()	{return _ID;};
	//A relative weight
	double			getWeight()	{return _weight;};
	void			setWeight(double weight)	{_weight = weight;};
	//Since we must remember the fitness components for each individual,
	//This is unfortunately not so elegant, but the alternative is not so nice either...
	virtual	double	evaluateScaffold(Individual* individual) = 0;

protected:
	//Data
	string		_name;
	int			_ID;	//unique
	double		_weight;
	//Methods
};

#endif // !defined(AFX_AGENT_H__09E891F7_2DAE_11D5_95D7_00C04F797C24__INCLUDED_)
