//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AgentSize.cpp: implementation of the AgentSize class.
//
//////////////////////////////////////////////////////////////////////

#include "AgentSize.h"
#include "Scaffold.h"
#include "Individual.h"
#include <cmath>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AgentSize::AgentSize()
{

}

AgentSize::AgentSize(int ID, double weight, double xsize, double ysize)
: Agent(ID, weight)
{
	_xsize = xsize;
	_ysize = ysize;
}

AgentSize::~AgentSize()
{

}

double AgentSize::evaluateScaffold(Individual* individual)
{
	if(_weight==0)
		return 0;
	double xsize, ysize, score = 0;
	//Find the extreme points in the x and y directions
	for(int i=0; i<individual->numberOfScaffolds(); i++)	{
		Scaffold* scaffold = individual->getScaffold(i);
		xsize = scaffold->getMaxX() - scaffold->getMinX();
		ysize = scaffold->getMaxY() - scaffold->getMinY();
		//Compare to the desired sizes
		score += 0.2*_weight*( fabs(xsize - _xsize) + fabs(ysize - _ysize) );
	}
	//Store the value with the individual
	individual->setSizeFitness(score);
	return score;
}