//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AgentSubdivision.cpp: implementation of the AgentSubdivision class.
//
//////////////////////////////////////////////////////////////////////

#include <iostream>
#include "AgentSubdivision.h"
#include "Individual.h"
#include "Scaffold.h"
#include <cmath>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AgentSubdivision::AgentSubdivision()
{

}

AgentSubdivision::AgentSubdivision(int ID, double weight, double ratio)
: Agent(ID, weight)
{
	_ratio = ratio;
}

AgentSubdivision::~AgentSubdivision()
{

}

double AgentSubdivision::evaluateScaffold(Individual* individual)
{
	if(_weight==0)
		return 0;
	double fitness = 0;
	for(int j=0; j<individual->numberOfScaffolds(); j++)	{
		Scaffold* scaffold = individual->getScaffold();
		//Calculate the ratio between vertices and segments
		double ratio = (double)scaffold->numberOfVertices() / (double)scaffold->numberOfSegments();
		//Since there will always be at least as many segments,
		//the value will be between 0 and 1.
		fitness += _weight*10*fabs(ratio - _ratio);
	}
	//Store the value with the individual
	individual->setSubdivisionsFitness(fitness);
	return fitness;
}