//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Attractor.h: interface for the Attractor class.
//
//	This class handles both attractors and repellors (the only difference is the sign)
//	It keeps track of the position and strength. It can be queried for the resulting force
//	in a given point.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ATTRACTOR_H__46203A35_1718_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_ATTRACTOR_H__46203A35_1718_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#define REP_NAME		"genr8Repellor"
#define REP_NAME_STAR	"genr8Repellor*"
#define ATTR_NAME		"genr8Attractor"
#define ATTR_NAME_STAR	"genr8Attractor*"

#define REP_POS_X			"repellorPositionX"
#define REP_POS_Y			"repellorPositionY"
#define REP_POS_Z			"repellorPositionZ"

#define ATTR_POS_X			"attractorPositionX"
#define ATTR_POS_Y			"attractorPositionY"
#define ATTR_POS_Z			"attractorPositionZ"

#include "Field.h"

class Attractor : public Field 
{
public:
	Attractor();
	Attractor(Vector pos, int ID, bool attr = true, int exp = 2, double konst = 2, bool drawn = false, bool singularity = true);
	virtual ~Attractor();

	virtual Vector	getForce(Vector pos);
	Vector	getPosition()	{return _pos;};
	void	drawAttractor(string attrLayer, string repLayer);
	//For use with repellor/attractor
	void	getRepellorPosition(int ID, bool attr);
private:
	//Data
	Vector	_pos;
	int		_exponent;
	bool	_drawn, _singularity;
	
};

#endif // !defined(AFX_ATTRACTOR_H__46203A35_1718_11D5_95D7_00C04F797C24__INCLUDED_)
