//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Branch.h: interface for the Branch class.
//
//	This class handles the branches. They are created as the scaffold is grown and attached to 
//	the vertices. After each step they are removed. This class is mostly used to store the data
//	about the branch. It is used by the scaffold as it tries to match the branches.
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BRANCH_H__E9F51B13_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_BRANCH_H__E9F51B13_17B7_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Vector.h"

class Region;
class Vertex;

class Branch
{
public:
	Branch();
	Branch(int type, Vertex* ver, int ID);
	virtual ~Branch();

	int		getType()	{return _type;};
	Vector	getDirection()	{return _direction;};
	void	setDirection(Vector dir)	{_direction = dir;};
	Vertex*	getStart()	{return _start;};
	int		getID()	{return _ID;};
	void	printInfo();

private:
	//Know your type and unique ID
	int _type, _ID;
	//Where you are headed
	Vector _direction;
	Vertex*	_start;
};

#endif // !defined(AFX_BRANCH_H__E9F51B13_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
