//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Edge.cpp: implementation of the Edge class.
//
//////////////////////////////////////////////////////////////////////

#include "Edge.h"
#include "Genotype.h"
#include <sstream>
#include <iostream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Edge::Edge()
{
	_name = EDGE;
}

Edge::Edge(int type)
:	Terminal()
{
	ostringstream tmp;
	tmp << type;
	_name = EDGE;
	_name.append(tmp.str());
	_type = type;
}

Edge::~Edge()
{

}

void Edge::reconstruct(int type, Genotype* &genome, int multi)
{
	if(multi!=0)
		genome->addGene(multi);
	//cout << "Reconstructing Edge, type " << type << endl;
	genome->addGene(type);
}