//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Edge.h: interface for the Edge class.
//
//	This class holds data for the Edge used in the grammar. The edges in the graph
//	are in the Segment-class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EDGE_H__E9F51B14_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_EDGE_H__E9F51B14_17B7_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Terminal.h"

class Edge : public Terminal  
{
public:
	Edge();
	Edge(int type);
	virtual ~Edge();

	void		reconstruct(int type, Genotype* &genome, int multi = 0);

	void		setType(int type)	{_type = type;};
	int			getType()	{return _type;};

private:
	//We need to keep track of the type as well
	int _type;

};

#endif // !defined(AFX_EDGE_H__E9F51B14_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
