//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Field.cpp: implementation of the Field class.
//
//////////////////////////////////////////////////////////////////////

#include "Field.h"
#include <cmath>
#include <iostream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Field::Field()
{

}

Field::~Field()
{

}

//Calcualte the magnitude as a function of distance

double Field::magnitude(double dist, double constant, int exponent, bool singularity)
{
	double mag;
	if(!singularity)	{
		double power = pow(dist, exponent);
		if(power==HUGE_VAL)
			return 0;
		if(power!=0)
			mag = constant/power;
		else
			return HUGE_MAG;
		if(mag==HUGE_VAL)
			return HUGE_MAG;
	}
	else	{
		if(dist > 1)
			mag = constant/pow(dist, exponent);
		else
			mag = dist*constant;
	}
	//cout << "Distance is " << dist << " and magnitude is " << mag << endl;
	return mag;
}