//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Field.h: interface for the Field class.
//
//	This is a parent class for all the classes that use some sort of force
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FIELD_H__4DC59884_1B08_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_FIELD_H__4DC59884_1B08_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Vector.h"

#define HUGE_MAG		10000000

class Field  
{
public:
	Field();
	virtual ~Field();

	int		getID()	{return _ID;};
	
	bool	isAttracting()	{return _attracting;};

protected:
	//Returns the magnitude of the force as a function of distance
	double	magnitude(double dist, double constant, int exponent, bool singularity = true);

	bool	_attracting;
	int		_ID;
	double	_const;
	
};

#endif // !defined(AFX_FIELD_H__4DC59884_1B08_11D5_95D7_00C04F797C24__INCLUDED_)
