//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// GeneticEngine.h: interface for the GeneticEngine class.
//
//	The genetic engine does the genetic operations. It can mutate a genome or create new ones by
//	crossover. The world owns a genetic engine that it uses to do the genetic operations
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GENETICENGINE_H__CC7CB26D_2CE4_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_GENETICENGINE_H__CC7CB26D_2CE4_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define MIN(a,b) (a < b ? a : b)

#include "Genotype.h"
#include <vector>
#include <algorithm>

using namespace std;

class GeneticEngine  
{
public:
	GeneticEngine();
	GeneticEngine(int mutProb, int crossProb);
	virtual ~GeneticEngine();

	void		setMutationProbability(int mutProb)	{_mutationProbability = mutProb;};
	void		mutate(Genotype* &genome);	//Mutates the genome
	//There are two types of crossover, although we only use the discrete one
	void		discreteCrossover(Genotype* mother, Genotype* father, Genotype* &son, Genotype* &daughter, int points);
	void		continuousCrossover(Genotype* mother, Genotype* father, Genotype* &offspring);

private:
	//Methods
	//Data
	int			_mutationProbability;
	int			_crossoverProbability;
};

#endif // !defined(AFX_GENETICENGINE_H__CC7CB26D_2CE4_11D5_95D7_00C04F797C24__INCLUDED_)
