//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Genotype.cpp: implementation of the Genotype class.
//
//////////////////////////////////////////////////////////////////////

#include "Genotype.h"
#include <iostream>
#include <sstream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Genotype::Genotype()
{

}

Genotype::Genotype(int length)
{
	//cout << "Creating genome with length " << length << endl;
	_genome.clear();
	_length = length;
	for(int i=0; i<length; i++)
		_genome.push_back( rand() % MAX_GENE );
}

Genotype::Genotype(Genotype* original)
{
	_genome.clear();
	_length = original->getLength();
	for(int i=0; i<_length; i++)
		_genome.push_back( original->getGene(i) );
}

Genotype::~Genotype()
{

}

void Genotype::printGenome()
{
	cout << "Genome has length " << _length << " and consists of:";
	for(int i=0; i<_length; i++) {
		if(i % 10 == 0)
			cout << endl;
		cout << _genome[i] << ", ";
	}
	cout << endl;
}

void Genotype::saveGenome(ofstream &file)
{
	//Save first the length of the genome and then the values
	file << _length << endl;
	for(int i=0; i<_length; i++)
		file << _genome[i] << " ";
	file << endl;
}

void Genotype::loadGenome(ifstream &file)
{
	//The first value is the length
	file >> _length;
	_genome.clear();
	int gene;
	//Then comes the values for the genes
	for(int i=0; i<_length; i++)	{
		file >> gene;
		_genome.push_back(gene);
	}
}

void Genotype::loadGenome(ifstream &file, int length)
{
	_length = length;
	_genome.clear();
	//cout << "Loading" << endl;
	int gene;
	for(int i=0; i<_length; i++)	{
		file >> gene;
		_genome.push_back(gene);
	}
}

//Stupid Maya forces us to use dots instead of space

string Genotype::str(bool dotsInsteadOfSpace)
{
	ostringstream streamgenome;
	//The population size is 1
	streamgenome << "1 ";
	//Stream the length
	streamgenome << _length;
	for(int i=0; i<_length; i++)	{
		if(dotsInsteadOfSpace)
			streamgenome << "." << _genome[i];
		else
			streamgenome << " " << _genome[i];
	}
	return streamgenome.str();
}
