//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Genotype.h: interface for the Genotype class.
//
//	The genotype class contains the genomes. Each individual owns a genotype
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GENOTYPE_H__2B8405DC_2380_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_GENOTYPE_H__2B8405DC_2380_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include <fstream>

#define MAX_GENE 1000

using namespace std;

class Genotype  
{
public:
	Genotype();
	Genotype(int length);
	Genotype(Genotype* original);
	virtual ~Genotype();

	int			getLength()	{return _length;};
	void		setLength(int length)	{_length = length;};
	int			getGene(int i)	{return _genome[i];};
	void		setGene(int i, int value)	{_genome[i] = value;};
	void		incGene(int i)	{_genome[i] += 1; _genome[i] = _genome[i] <= MAX_GENE ? _genome[i] : 0;};
	void		decGene(int i)	{_genome[i] -= 1; _genome[i] = _genome[i] >= 0 ? _genome[i] : MAX_GENE;};
	void		addGene(int value)	{_genome.push_back(value); _length++;};
	void		addRandGene()	{_genome.push_back(rand() % MAX_GENE); _length++;};
	void		clear()	{_length = 0; _genome.clear();};
	//Printing
	void		printGenome();
	string		str(bool dotsInsteadOfSpace = false);
	//Saving and loading
	void		saveGenome(ofstream &file);
	void		loadGenome(ifstream &file);
	void		loadGenome(ifstream &file, int length);

private:
	int			_length;	//Keep track of the length
	vector<int>	_genome;	//The genome is an array of integers, we do not use bits as is standard for GE
};

#endif // !defined(AFX_GENOTYPE_H__2B8405DC_2380_11D5_95D7_00C04F797C24__INCLUDED_)
