//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Gravity.h: interface for the Gravity class.
//
//	This class keeps track of the gravity in the world.
//	We have a direction and magnitude. Negative magnitudes represent negative directions
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAVITY_H__4DC59885_1B08_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_GRAVITY_H__4DC59885_1B08_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Field.h"

typedef enum Direction{X, Y, Z};

class Gravity : public Field  
{
public:
	Gravity();
	Gravity(Direction dir, int ID, double konst = 100);
	virtual ~Gravity();
	
	virtual Vector	getForce(Vector pos);
	
private:
	//Data
	Direction _dir;
};

#endif // !defined(AFX_GRAVITY_H__4DC59885_1B08_11D5_95D7_00C04F797C24__INCLUDED_)
