//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// LSystem.h: interface for the LSystem class.
//
//	This class is for the L-system non-terminal when generating the grammar.
//	It is the start symbol and it starts expanding by a call from BNF-class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LSYSTEM_H__B8885B4F_1ECA_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_LSYSTEM_H__B8885B4F_1ECA_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NonTerminal.h"

class LSystem : public NonTerminal  
{
public:
	LSystem();
	LSystem(BNF* grammar, BNFtype bnfType);
	virtual ~LSystem();

	Sentence*		getProductionRule(int gene, bool terminal);
	void			reconstruct(Sentence* sent, Genotype* &genome, int multi = 0);
	virtual void	expand(int depth, int predecessor = -1);
protected:
	void	addRewriteRule(int predecessor, int depth);
	void	completeRewriteRules(int depth);

};

#endif // !defined(AFX_LSYSTEM_H__B8885B4F_1ECA_11D5_95D7_00C04F797C24__INCLUDED_)
