//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// MELUtilities.h: interface for the MELUtilities class.
//
//	This file has a lot of utilities that are used by a lot of classes.
//	Most of them are for communicating with Maya using MEL, but some ar file-handling and other stuff
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MELUTILITIES_H__46203A36_1718_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_MELUTILITIES_H__46203A36_1718_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DEFAULT_LOCATION "\\bin\\plug-ins\\"
#define PLUS_VAR			"Plus"
#define PLUS_VAR_LENGTH		4
#define MINUS_VAR			"Minus"
#define MINUS_VAR_LENGTH	5
#define HAT_VAR				"Hat"
#define HAT_VAR_LENGTH		3
#define AMPERSAND_VAR		"Ampersand"
#define AMPERSAND_VAR_LENGTH	9
#define FORWARDSLASH_VAR	"Forwardslash"
#define FORWARDSLASH_VAR_LENGTH	12
#define BACKSLASH_VAR		"Backslash"
#define BACKSLASH_VAR_LENGTH	9
#define TILDE_VAR			"Tilde"
#define TILDE_VAR_LENGTH	5
#define ARROW_VAR			"Arrow"
#define ARROW_VAR_LENGTH	5
#define LEFT_BRACKET_VAR	"LeftBracket"
#define LEFT_BRACKET_VAR_LENGTH	11
#define RIGHT_BRACKET_VAR	"RightBracket"
#define RIGHT_BRACKET_VAR_LENGTH	12
#define LESSER_THAN			"<"
#define LESSER_THAN_VAR		"LesserThan"
#define LESSER_THAN_VAR_LENGTH	10
#define GREATER_THAN		">"
#define GREATER_THAN_VAR	"GreaterThan"
#define GREATER_THAN_VAR_LENGTH	11
#define NUMBER_VAR			"Number"
#define NUMBER_VAR_LENGTH	6
#define SPACE_VAR			"."
#define SPACE_VAR_LENGTH	1
#define END_VAR				"End"
#define END_VAR_LENGTH		3
#define ZERO_VAR			"Zero"
#define ZERO_VAR_LENGTH		4
#define ONE_VAR				"One"
#define ONE_VAR_LENGTH		3
#define TWO_VAR				"Two"
#define TWO_VAR_LENGTH		3
#define THREE_VAR			"Three"
#define THREE_VAR_LENGTH	5
#define FOUR_VAR			"Four"
#define FOUR_VAR_LENGTH		4
#define FIVE_VAR			"Five"
#define FIVE_VAR_LENGTH		4
#define SIX_VAR				"Six"
#define SIX_VAR_LENGTH		3
#define SEVEN_VAR			"Seven"
#define SEVEN_VAR_LENGTH	5
#define EIGHT_VAR			"Eight"
#define EIGHT_VAR_LENGTH	5
#define NINE_VAR			"Nine"
#define NINE_VAR_LENGTH		4
#define DOT_VAR				"Dot"
#define DOT_VAR_LENGTH		3
#define EQUAL				"="
#define INT_VAR				"int"
#define DOUBLE_VAR			"double"
#define STRING_VAR			"string"

typedef enum {INTEGER, DOUBBLOAT, STRING} varType;

#include <maya/MGlobal.h>
#include <maya/MPxCommand.h>
#include <maya/MString.h>
#include <maya/MStringArray.h>
#include <maya/MStatus.h>

#include <string>
#include <vector>
#include <iostream>
#include <fstream>

using namespace std;

void eval(std::string command);
void refresh();
// Utilities to get MEL values from internal variables
//Use these function when the MEL-command returns a value that you wish to get
char*	getCharResults(string cmd);
string	getStringResults(string cmd);
string*	getStringPointerResults(string cmd);
char*	getCharResult(string cmd);
string*	getStringPointerResult(string cmd);
int		getIntResult(string cmd);
double	getDoubleResult(string cmd);
vector<double>	getDoubleResults(string cmd);

//Optionvar
bool	getOptionVar(string variable, int &value, string &cmd, bool valueOnly = false, bool remove = true);
bool	getOptionVar(string variable, double &value, string &cmd, bool valueOnly = false, bool remove = true);
bool	getOptionVar(string variable, bool &value, string &cmd, bool valueOnly = false, bool remove = true);
bool	getOptionVar(string variable, string &value, string &cmd, bool valueOnly = false, bool remove = true);

bool	getOptionVar(string variable, int &value, bool remove = true);
bool	getOptionVar(string variable, double &value, bool remove = true);
bool	getOptionVar(string variable, bool &value, bool remove = true);
bool	getOptionVar(string variable, string &value, bool remove = true);
bool	getOptionVar(string variable, vector<double> &value, bool remove = true);

void	saveOptionVar(string variable, ofstream &file, varType var);
void	loadOptionVar(ifstream &file);

//Not a MEL-function, but a utility...
bool	opengenr8File(string fileName, ifstream &file, bool fullPath = false, bool encoded = false);
bool	opengenr8File(string fileName, ofstream &file, bool fullPath = false, bool encoded = false);
//Because of stupid Maya we have to encode the special characters.
//Otherwise, Maya can not handle the strings
string	encodeString(string &str);
string	decodeString(string &str);

//This is never used. We never construct any objects of this kind

class MELUtilities  
{
public:
	MELUtilities();
	virtual ~MELUtilities();
};

#endif // !defined(AFX_MELUTILITIES_H__46203A36_1718_11D5_95D7_00C04F797C24__INCLUDED_)
