//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Modifier.h: interface for the Modifier class.
//
//	Modifier is a non-terminal that is used for the development of the grammar.
//	This is the only non-terminal that is recursive in its production rules.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MODIFIER_H__B8885B51_1ECA_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_MODIFIER_H__B8885B51_1ECA_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NonTerminal.h"

class Modifier : public NonTerminal  
{
public:
	Modifier();
	Modifier(BNF* grammar, BNFtype bnfType);
	virtual ~Modifier();

	Sentence*	getProductionRule(int gene, bool terminal);
	void		reconstruct(Sentence* sent, Genotype* &genome, int multi = 0);
};

#endif // !defined(AFX_MODIFIER_H__B8885B51_1ECA_11D5_95D7_00C04F797C24__INCLUDED_)
