//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// NurbsSurface.h: interface for the NurbsSurface class.
//
//	This class handle boundaries that are nurbs-surfaces.
//	They are owned by the boundary class.
//	It can be queried for intersections.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NURBSSURFACE_H__F9E4BEC3_21ED_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_NURBSSURFACE_H__F9E4BEC3_21ED_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Vector.h"
#include <maya/MFnNurbsSurface.h>

class NurbsSurface  
{
public:
	NurbsSurface();
	NurbsSurface(MDagPath surf, int ID);
	virtual ~NurbsSurface();

	bool	getIntersection(Vector pos, Vector dir, Vector &intersect);
	//Get the intersection for the orthogonal directions
	bool	getIntersection(Vector pos, Vector dir, Vector &xintersect, Vector &yintersect, Vector &zintersect);
	int		getID()	{return _ID;};
protected:
	MFnNurbsSurface*	_surf;	//The Maya object
	int					_ID;
};

#endif // !defined(AFX_NURBSSURFACE_H__F9E4BEC3_21ED_11D5_95D7_00C04F797C24__INCLUDED_)
