//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Operator.cpp: implementation of the Operator class.
//
//////////////////////////////////////////////////////////////////////

#include "Operator.h"
#include <sstream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Operator::Operator()
{
	
}

Operator::Operator(BNF* grammar, BNFtype bnfType)
: NonTerminal(grammar, bnfType)
{
	_name = OPERATOR;
}

Operator::~Operator()
{

}

Sentence* Operator::getProductionRule(int gene, bool terminal)
{
	int prod = gene % 7;
	ostringstream str;
	switch(prod)	{
	case 0:	str << "+";
			break;
	case 1:	str << "-";
			break;
	case 2: str << "^";
			break;
	case 3: str << "&";
			break;
	case 4: str << "/";
			break;
	case 5: str << "\\";
			break;
	default : str << "~";
	}
	return new Sentence(str.str());
}

void Operator::reconstruct(Sentence* sent, Genotype* &genome, int multi)
{

}