//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Operator.h: interface for the Operator class.
//
//	Keep track of the non-terminal operator in the grammar.
//	Currently, this is not used by any BNF.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OPERATOR_H__E9F51B15_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_OPERATOR_H__E9F51B15_17B7_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NonTerminal.h"



class Operator : public NonTerminal  
{
public:
	Operator();
	Operator(BNF* grammar, BNFtype bnfType);
	virtual ~Operator();

	Sentence*	getProductionRule(int gene, bool terminal);
	void		reconstruct(Sentence* sent, Genotype* &genome, int multi = 0);
	
private:
	

};

#endif // !defined(AFX_OPERATOR_H__E9F51B15_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
