//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// OperatorType.cpp: implementation of the OperatorType class.
//
//////////////////////////////////////////////////////////////////////

#include "OperatorType.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

OperatorType::OperatorType()
{

}

OperatorType::OperatorType(OperatorTypes op)
:	Terminal()
{
	_operator = op;
	switch(op)	{
	case TURN_RIGHT :
		_name = "+";
		break;
	case TURN_LEFT :
		_name = "-";
		break;
	case PITCH_DOWN :
		_name = "&";
		break;
	case PITCH_UP :
		_name = "^";
		break;
	case ROLL_LEFT :
		_name = "\\";
		break;
	case ROLL_RIGHT :
		_name = "/";
		break;
	case CHANGE_DIRECTION :
		_name = "~";
		break;
	case PUSH :
		_name = "[";
		break;
	case POP :
		_name = "]";
		break;
	case LEFT_SENSITIVE :
		_name = "<";
		break;
	case RIGHT_SENSITIVE :
		_name = ">";
		break;
	case TRANSFORM :
		_name = "->";
		break;
	}
}

OperatorType::~OperatorType()
{

}

void OperatorType::setOperatorType(const OperatorTypes &op)
{
	_operator = op;
	switch(op)	{
	case TURN_RIGHT :
		_name = "+";
		break;
	case TURN_LEFT :
		_name = "-";
		break;
	case PITCH_DOWN :
		_name = "&";
		break;
	case PITCH_UP :
		_name = "^";
		break;
	case ROLL_LEFT :
		_name = "\\";
		break;
	case ROLL_RIGHT :
		_name = "/";
		break;
	case CHANGE_DIRECTION :
		_name = "~";
		break;
	case PUSH :
		_name = "[";
		break;
	case POP :
		_name = "]";
		break;
	case LEFT_SENSITIVE :
		_name = "<";
		break;
	case RIGHT_SENSITIVE :
		_name = "<";
		break;
	case TRANSFORM :
		_name = "->";
		break;
	}
}