//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// OperatorType.h: interface for the OperatorType class.
//
//	This class keeps track of operator terminals for the grammar
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OPERATORTYPE_H__E9F51B16_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_OPERATORTYPE_H__E9F51B16_17B7_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Terminal.h"

//Enumerate the operators

typedef enum{TURN_RIGHT, TURN_LEFT, PITCH_UP, PITCH_DOWN, ROLL_RIGHT, ROLL_LEFT, 
			CHANGE_DIRECTION, PUSH, POP, LEFT_SENSITIVE, RIGHT_SENSITIVE, TRANSFORM}	OperatorTypes;

class OperatorType : public Terminal  
{
public:
	OperatorType();
	OperatorType(OperatorTypes op);
	virtual ~OperatorType();

	void		reconstruct(Sentence* sent, Genotype* &genome);

	void setOperatorType(const OperatorTypes &op);
	OperatorTypes getOperatorType()	{return _operator;};

private:
	OperatorTypes _operator;

};

#endif // !defined(AFX_OPERATORTYPE_H__E9F51B16_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
