//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// PolygonSurface.h: interface for the PolygonSurface class.
//
//	This is similar to the NurbsSurface class except that works with polygons instead.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POLYGONSURFACE_H__32253900_1F94_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_POLYGONSURFACE_H__32253900_1F94_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Vector.h"
#include <maya/MFnMesh.h>
#include <vector>

#define TOL 0.01

class PolygonSurface  
{
public:
	PolygonSurface();
	PolygonSurface(MDagPath surf, int ID);
	virtual ~PolygonSurface();

	bool	getIntersection(Vector pos, Vector dir, Vector &intersect);
	//Get the intersection for the orthogonal directions
	bool	getIntersection(Vector pos, Vector dir, Vector &xintersect, Vector &yintersect, Vector &zintersect);
	int		getID()	{return _ID;};
protected:
	MFnMesh*		_surf;
	int				_ID;
};

#endif // !defined(AFX_POLYGONSURFACE_H__32253900_1F94_11D5_95D7_00C04F797C24__INCLUDED_)
