// ProductionRule.h: interface for the ProductionRule class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PRODUCTIONRULE_H__E9F51B10_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_PRODUCTIONRULE_H__E9F51B10_17B7_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include <string>

using namespace std;

class ProductionRule  
{
public:
	ProductionRule();
	ProductionRule(bool terminal, int weight = 1)	{_terminal = terminal; _weight = weight;};
	ProductionRule(char* expansion, bool terminal = true, int weight = 1);
	virtual ~ProductionRule();

	//void			setProductionRule(std::string* expansion);
	void			setProductionRule(char* expansion);
	std::vector<char*>	getProductionRule()	{return _expansion;};
	bool			isTerminal()	{return _terminal;};
	int				getWeight()	{return _weight;};
protected:
	std::vector<char*>	_expansion;	//What it is expanded to
	bool				_terminal;	//If the expansion is a terminal, ie no deeper after this expansion
	int					_weight;	//When choosing a random production rule, make it more likely that this rule is choosen by increasing this parameter
};

#endif // !defined(AFX_PRODUCTIONRULE_H__E9F51B10_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
