//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Sentence.h: interface for the Sentence class.
//
//	We have oru own class for hadling sentences to make life easier.
//	The sentece is simply a vector containg a bunch of words
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SENTENCE_H__E9F51B0E_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_SENTENCE_H__E9F51B0E_17B7_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Word.h"
#include <vector>
#include <fstream>

using namespace std;

class Sentence  
{
public:
	Sentence();
	Sentence(string str);
	virtual ~Sentence();

	void		addWord(Word* word)	{_sentence.push_back(word);};
	Word*		getWord(int i)	{return _sentence[i];};
	int			numberOfWords()	{return _sentence.size();};
	int			numberOfWords(string name);
	void		clear()	{_sentence.clear();};
	void		printSentence();
	int			findWord(string word, int i = 0);	//Returns the index of the first occurence, starts looking at i
	Sentence*	getSentence(int start, int end);	//Return the part of the sentence between start and end
	Sentence*	getLine(int i=0);	//Gets the words between to end-symbols
	int			numberOfLines();
	int			numberOfEdgeTypes();	//Returns the number of different edge types in the sentence
	string		str(bool end = false, bool dotsInsteadOfSpace = false);
	bool		isRewriteRule()	{return findWord("->")!=-1;};	//Use when you have a line

	void		saveSentence(ofstream &file);
private:
	//Methods
	//Data
	vector<Word*> _sentence;
	
};

#endif // !defined(AFX_SENTENCE_H__E9F51B0E_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
