//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Successor.cpp: implementation of the Successor class.
//
//////////////////////////////////////////////////////////////////////

#include "Successor.h"
#include "Modifier.h"
#include "Edge.h"
#include <iostream>
#include <sstream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Successor::Successor()
{
	
}

Successor::Successor(BNF* grammar, BNFtype bnfType)
: NonTerminal(grammar, bnfType)
{
	_name = SUCCESSOR;
}

Successor::~Successor()
{

}

Sentence* Successor::getProductionRule(int gene, bool terminal)
{
	ostringstream str;
	if(_BNFtype==REVERSIBLE)
		str << MODIFIER << " " << EDGE;
	else
		str << "{ " << MODIFIER << " } " << EDGE;
	return new Sentence(str.str());
}

void Successor::reconstruct(Sentence* sent, Genotype* &genome, int multi)
{
	cout << "Reconstructing Successor: " << endl;
	sent->printSentence();
	//Only one production rule
	genome->addRandGene();
	int last = sent->numberOfWords();
	Modifier* mod = new Modifier;
	//And the Edge
	Edge* edg = new Edge;
	edg->reconstruct(sent->getWord(last-1)->getEdgeType(), genome);
	mod->reconstruct(sent->getSentence(0, last-1), genome);
	
}