//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Terminal.h: interface for the Terminal class.
//
//	This is the parent-class for all nodes that are used when generating a grammar.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TERMINAL_H__E9F51B0F_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_TERMINAL_H__E9F51B0F_17B7_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Word.h"
#include "Sentence.h"
#include "Genotype.h"

#define AXIOM					"Axiom"
#define CONDITION				"Condition"
#define CONSTANT				"Constant"
#define EDGE					"Edge"
#define EDGE_X					"EdgeX"
#define EDGE_Y					"EdgeY"
#define EDGE_Z					"EdgeZ"
#define IF						"If"
#define L_SYSTEM				"L-System"
#define MODIFIER				"Modifier"
#define OPERATOR				"Operator"
#define PREDECESSOR				"Predecessor"
#define REWRITE_RULE			"RewriteRule"
#define START_EDGE				"StartEdge"
#define SUCCESSOR				"Successor"



class Terminal : public Word  
{
public:
	Terminal();
	virtual ~Terminal();

	//virtual void	reconstruct(Sentence* sent, Genotype* &genome) = 0;

	Sentence*	getSentence()	{return _sentence;};
	void		getFullSentence(Sentence* &sentence);
protected:
	Sentence*		_sentence;	//Store the expansion
	
};

#endif // !defined(AFX_TERMINAL_H__E9F51B0F_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
