//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Word.cpp: implementation of the Word class.
//
//////////////////////////////////////////////////////////////////////

#include "Word.h"
#include "MELUtilities.h"
#include "Terminal.h"
#include <iostream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Word::Word()
{

}

Word::Word(string name)
{
	_name = name;
}

Word::~Word()
{

}

string Word::getName(bool literal)
{
	return _name;
}

void Word::printWord()
{
	if(_name==END_VAR)
		cout << endl;
	else
		cout << _name.c_str() << " ";
		
}

int Word::getEdgeType()
{
	if(_name.substr(0, 4)==EDGE)	{
		int pos = _name.find('_'), length = _name.size();
		if(pos==-1)
			return atoi(_name.substr(4, length-4).c_str());
		else
			return atoi(_name.substr(4, pos-3).c_str());
	}

	return -1;
}

bool Word::getEdgeTypeAndCount(EdgeTypeAndCount &edge)
{
	edge.clear();
	if(_name.substr(0, 4)!=EDGE)
		return false;
	int pos = _name.find('_', 4), length = _name.size();
	if(pos==-1)	{	//No counter, just a type
		edge._counterType = NO_COUNTER;
		edge._type = atoi(_name.substr(4, length - 4).c_str());
	}
	else	{
		//Get the type
		edge._type = atoi(_name.substr(4, pos - 4).c_str());
		//Get counter
		if(_name.find("i+1"))
			edge._counterType = I_PLUS_ONE;
		else if(_name.find("i-1"))
			edge._counterType = I_MINUS_ONE;
		else if(_name.find('i'))
			edge._counterType = I;
		else	{//Numeric value
			int length = _name.size();
			edge._counter = atoi(_name.substr(pos, length-pos).c_str());
			edge._counterType = NUMERIC;
		}
	}
	return true;
}

CounterType Word::getCount(int &counter)
{
	counter = -1;
	if(_name.substr(0, 4)==EDGE)	{
		int pos = _name.find('_', 4);
		if(pos!=-1)	{
			if(_name.find("i+1"))
				return I_PLUS_ONE;
			else if(_name.find("i-1"))
				return I_MINUS_ONE;
			else if(_name.find('i'))
				return I;
			else	{//Numeric value
				int length = _name.size();
				counter = atoi(_name.substr(pos, length-pos).c_str());
				return NUMERIC;
			}
		}
	}
	return NO_COUNTER;
}