//
// Copyright (C) 2001 Martin Hemberg. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Word.h: interface for the Word class.
//
//	This class facilitates the string handling by providing an object for each word (the sentences are so short and constrained, so this makes life a lot easier)
//	The Sentence-class consists of a vector of Word.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WORD_H__E9F51B0C_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
#define AFX_WORD_H__E9F51B0C_17B7_11D5_95D7_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>

using namespace std;
//The different counter types that is possible in the grammar
typedef enum {NO_COUNTER, NUMERIC, I, I_PLUS_ONE, I_MINUS_ONE} CounterType;

struct EdgeTypeAndCount
{
	int				_type, _counter;
	CounterType		_counterType;
	void clear()	{_type = -1; _counter = -1; _counterType = NO_COUNTER;};
};

class Word  
{
public:
	Word();
	Word(string name);
	virtual ~Word();

	string		getName(bool literal = false);
	void		printWord();
	//Some functions to access data about edges
	int			getEdgeType();	//Return -1 if the word is not EdgeX
	bool		getEdgeTypeAndCount(EdgeTypeAndCount &edge);
	CounterType	getCount(int &count);
protected:
	string		_name;	//The actual word

};

#endif // !defined(AFX_WORD_H__E9F51B0C_17B7_11D5_95D7_00C04F797C24__INCLUDED_)
